////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>

#ifdef HAVE_LIBPCRECPP
#include <pcrecpp.h>
#endif

#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_dir_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_dir_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_file_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_file_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    rec_item_dir_type rec_item_dir;
    rec_item_file_type rec_item_file;
    delete_error_type delete_error;
};

static tnt::ComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "\244\001\000\000\310\001\000\000\323\001\000\000\326\001\000\000\222\002\000\000\266\010"
  "\000\000\267\010\000\000\271\010\000\000\272\010\000\000\274\010\000\000\275\010\000\000\370\010\000\000\013\t\000"
  "\000\016\t\000\000\017\t\000\000\245\t\000\000\373\t\000\000\032\n\000\0004\n\000\0005\n\000\0006\n\000\0008\n\000"
  "\000R\n\000\000S\n\000\000b\n\000\000\223\n\000\000\242\n\000\000\276\n\000\000\306\n\000\000\307\n\000\000\311\n\000"
  "\000\363\n\000\000\376\n\000\000H\013\000\000S\013\000\000X\013\000\000\214\013\000\000\273\013\000\000\363\013\000"
  "\000\373\013\000\0006\014\000\000\?\014\000\000d\014\000\000m\014\000\000w\014\000\000x\014\000\000z\014\000\000\231"
  "\014\000\000\233\014\000\000\246\014\000\000\265\014\000\000\266\014\000\000\270\014\000\000\333\014\000\000\347\014"
  "\000\000\360\014\000\000\367\014\000\000\370\014\000\000\373\014\000\000\374\014\000\000\375\014\000\000\376\014\000"
  "\000\377\014\000\000\000\015\000\000\001\015\000\000\003\015\000\000\015\015\000\000\034\015\000\000 \015\000\000!"
  "\015\000\000\"\015\000\000$\015\000\000w\015\000\000\234\015\000\000\312\015\000\000\032\016\000\000c\016\000\000d"
  "\016\000\000f\016\000\000\241\016\000\000\253\016\000\000\272\016\000\000\275\016\000\000\354\016\000\000\360\016\000"
  "\0002\017\000\000[\017\000\000\203\017\000\000\204\017\000\000\212\017\000\000\220\017\000\000\227\017\000\000\252"
  "\017\000\000\336\017\000\000\340\017\000\000\341\017\000\000)\020\000\000*\020\000\0002\020\000\000O\020\000\000V\020"
  "\000\000^\020\000\000_\020\000\000a\020\000\000b\020\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t"
  "\n\t\t\n\t\t<script type=\"text/javascript\" src=\"treeview.js\"></script>\n\t\t<script type=\"text/javascript\"><!--"
  "\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = \"recordings.html\?sort=&filter=\" + enc"
  "odeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = \"\";\n\t\t\trecordingN"
  "odes = window.document.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfor (idx = 0; idx < recordingNodes.length"
  "; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].st"
  "yle.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + \",\"; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNode"
  "s = window.document.getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandNodes.length;"
  " idx++) {\n\t\t\t\texpandNodes[idx].src = \"img/minus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElement"
  "sBySelector(\"img.recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[i"
  "dx].src = \"img/folder_open.png\";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction"
  " CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfo"
  "r (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recording"
  "s') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document"
  ".getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\t"
  "expandNodes[idx].src = \"img/plus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector(\"img.re"
  "cording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = \"img/fold"
  "er_closed.png\";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body>\n\t\t"
  "\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<div class=\"boxheader\"><div><div></div></div></div>\n\t\t\t\n\t\t\t"
  "<form method=\"post\" name=\"recordings\" action=\"recordings.ecpp\">\n\t\t\t<div class=\"recordings\">\n\t\t\t<ul cl"
  "ass=\"recordingslist\" style=\"display: block;\">\n\n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class=\"withmargin\">\n\t"
  "\t\t\t<button class=\"red\" type=\"submit\"></button>\n\t\t\t</div>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n"
  "\n\n\n\n\t<li class=\"recording\">\n\t\t\n\t\t<ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n\t"
  "\t</ul>\n\t</li>\n\t<li class=\"recording\">\n\t   \n\t</li>\n\n\n\n<a href=\"recordings.html\?sort=name&filter=\" al"
  "t=\"\" /></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=date&filter=\" alt=\"\" /></a>\n<span cl"
  "ass=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter\""
  " onchange=\"filterRecordings(this)\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" src="
  "\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\n\n<a href=\"recordings.html\?todel"
  "=\" ><img src=\"\" alt=\"\" /></a>\n\n\n<a href=\"edit_recording.html\?recid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n"
  "\n\n\n\n\n\n\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n\t<div class=\"recording_item\" onclick=\"Toggle(this)\">"
  "\n\t\t<div class=\"recording_imgs\"><img class=\"recording_expander\" src=\"\" alt=\"\" /><img class=\"recording_fold"
  "er\" src=\"\" alt=\"\" /></div>\n\t\t<div class=\"recording_spec\">\n\t\t\t<div class=\"recording_name\"></div>\n\t  "
  "  </div>\n\t\t<div class=\"recording_actions\">&nbsp;</div>\n\t</div>\n\n\n\n\t<div class=\"recording_item\">\n\t<div"
  " class=\"recording_imgs\"><img src=\"\" alt=\"on_dvd\"  /><input type=\"checkbox\" name=\"deletions\" value=\"\" /></"
  "div>\n\t<div class=\"recording_spec\">\n\t\t<div class=\"recording_day\"></div>\n\t\t<div class=\"recording_duration"
  "\"></div>\n\t\t<div class=\"recording_name\"><a ><br /><span></span><span>&nbsp;</span></a></div>\n\t</div>\n\t<div c"
  "lass=\"recording_actions\">\n\t\t\n\t\t<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />\n"
  "\t\t\n\t</div>\n\t<div class=\"recording_arch\"></div>\n\t</div>\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    rec_item_dir(*this, "rec_item_dir"),
    rec_item_file(*this, "rec_item_file"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string sort = tnt::stringTo<string>("sort", "string", qparam.param("sort"), reply.out().getloc());
string todel = tnt::stringTo<string>("todel", "string", qparam.param("todel"), reply.out().getloc());
string diskinfo = tnt::stringTo<string>("diskinfo", "string", qparam.param("diskinfo"), reply.out().getloc());
string filter = tnt::stringTo<string>("filter", "string", qparam.param("filter"), reply.out().getloc());
typedef std::vector<string> deletions_type;
deletions_type deletions;
tnt::convertRange("deletions", "string", qparam.begin("deletions"), qparam.end(), deletions, reply.out().getloc());
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 38 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

currentSort = LiveSetup().GetLastSortingMode();
if (!sort.empty()) {
	if (sort == "date")
		currentSort = (currentSort == "dateasc") ? "datedesc" : "dateasc";
	else if (sort == "name")
		currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
	LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
	if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	deletions.push_back(todel);
}
for (deletions_type::const_iterator it = deletions.begin(); it != deletions.end(); ++it) {
	if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
		RemoveRecordingTask task(*it);
		LiveTaskManager().Execute(task);
		if (!task.Result())
			deleteResult += string() + tr("ERROR:") + " " + task.Error() + "<br/>";
		else
			deleteResult += string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
	}
	else {
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	}
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));

  // <& pageelems.doc_type ...
  { 
#line 85 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 85 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 88 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 89 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 89 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 90 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 90 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script type="text/javascript" src="treeview.js"></script>\n\t\t<script type="text/javascript"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = "recordings.html\?sort=
#line 95 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << data[4]; // &filter=" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = "";\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + ","; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/minus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_open.png";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/plus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_closed.png";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 138 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 138 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[5]; // \n
#line 139 "recordings.ecpp"

if (!deleteResult.empty()) {

  reply.out() << data[6]; // \t\t
  // <& menu ...
  { 
#line 142 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 142 "recordings.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("recordings"), reply.out().getloc() ) );
#line 142 "recordings.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("recordings.delete_error"), reply.out().getloc() ) );
#line 142 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[7]; // \n
#line 143 "recordings.ecpp"

} else {

  reply.out() << data[8]; // \t\t
  // <& menu ...
  { 
#line 146 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 146 "recordings.ecpp"
    _tnt_cq5.add( "active", tnt::toString(("recordings"), reply.out().getloc() ) );
#line 146 "recordings.ecpp"
    _tnt_cq5.add( "component", tnt::toString(("recordings.sort_options"), reply.out().getloc() ) );
#line 146 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[9]; // \n
#line 147 "recordings.ecpp"

}

  reply.out() << data[10]; // \t\t<div class="inhalt">\n\t\t\t<div class="boxheader"><div><div>
#line 151 "recordings.ecpp"
  reply.sout() << ( string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << data[11]; // </div></div></div>\n
#line 152 "recordings.ecpp"

#if VDRVERSNUM >= 20301
			int rec_cnt;
			{
				LOCK_RECORDINGS_READ;
				rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
			}
			if (rec_cnt == 0) {
#else
			if (Recordings.Count() == 0) { // Access VDRs global cRecordings Recordings instance.
#endif

  reply.out() << data[12]; // \t\t\t
#line 164 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << data[13]; // \n
#line 165 "recordings.ecpp"

			} else {

  reply.out() << data[14]; // \t\t\t<form method="post" name="recordings" action="recordings.ecpp">\n\t\t\t<div class="recordings">\n\t\t\t<ul class="recordingslist" style="display: block;">\n
  // <& recordings.recordings_item ...
  { 
#line 171 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 171 "recordings.ecpp"
    _tnt_cq6.add( "filter", tnt::toString((currentFilter), reply.out().getloc() ) );
#line 171 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[15]; // \n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class="withmargin">\n\t\t\t\t<button class="red" type="submit">
#line 175 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << data[16]; // </button>\n\t\t\t</div>\n\t\t\t</form>\n
#line 178 "recordings.ecpp"

			}

  reply.out() << data[17]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[18]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[19]; // \n
  reply.out() << data[20]; // \n\n
  reply.out() << data[28]; // \n
  reply.out() << data[29]; // \n\n
  reply.out() << data[44]; // \n
  reply.out() << data[45]; // \n\n
  reply.out() << data[50]; // \n
  reply.out() << data[51]; // \n\n
  reply.out() << data[56]; // \n
  reply.out() << data[57]; // \n\n\n
  reply.out() << data[63]; // \n
  reply.out() << data[64]; // \n\n
  reply.out() << data[69]; // \n
  reply.out() << data[70]; // \n\n
  reply.out() << data[76]; // \n
  reply.out() << data[77]; // \n\n
  reply.out() << data[101]; // \n
  reply.out() << data[102]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string filter = qparam.param("filter");
typedef std::vector<std::string> path_type;
path_type path;
std::copy(qparam.begin("path"), qparam.end(), std::back_inserter(path));
int level = qparam.has("level") ? tnt::stringToWithDefault<int>(qparam.param("level"), ( 0), reply.out().getloc()) : ( 0);
int counter = qparam.has("counter") ? tnt::stringToWithDefault<int>(qparam.param("counter"), ( 0), reply.out().getloc()) : ( 0);
string idHash = qparam.has("idHash") ? tnt::stringToWithDefault<string>(qparam.param("idHash"), ( ""), reply.out().getloc()) : ( "");
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 196 "recordings.ecpp"

RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
RecordingsMap::iterator iter;
RecordingsMap::iterator end = recordingsTree->end(path);
list<RecordingsItemPtr> recItems;
list<RecordingsItemPtr>::iterator recIter;

for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	if (recItem->IsDir()) {
		recItems.push_back(recItem);
	}
}
if (currentSort == "namedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingName);
else
	recItems.sort(RecordingsItemPtrCompare::ByAscendingName);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
	RecordingsItemPtr recItem = *recIter;
	counter++;

  reply.out() << data[21]; // \t<li class="recording">\n\t\t
  // <& rec_item_dir ...
  { 
#line 218 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 218 "recordings.ecpp"
    _tnt_cq7.add( "level", tnt::toString((recItem->Level()), reply.out().getloc() ) );
#line 218 "recordings.ecpp"
    _tnt_cq7.add( "name", tnt::toString((recItem->Name()), reply.out().getloc() ) );
#line 218 "recordings.ecpp"
  main().rec_item_dir(request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[22]; // \n
#line 219 "recordings.ecpp"

#if TNT_QUERYPARAMS_NO_BOOL
		tnt::QueryParams recItemParams(qparam);
#else
		tnt::QueryParams recItemParams(qparam, false);
#endif
		for (path_type::const_iterator i = path.begin(); i != path.end(); ++i) {
			recItemParams.add("path", *i);
		}
		recItemParams.add("path", recItem->Name());
		recItemParams.add("level", lexical_cast<string, int>(level + 1));
		recItemParams.add("filter", filter);
		string combinedId = recItem->Name() + "_";
		combinedId += counter + "_" + level;
		idHash = MD5Hash(combinedId);

  reply.out() << data[23]; // \t\t<ul id="fldr_
#line 235 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << data[24]; // " class="recordingslist" style="display: none;">\n
#line 236 "recordings.ecpp"

		callComp("recordings.recordings_item", request, reply, recItemParams);

  reply.out() << data[25]; // \t\t</ul>\n\t</li>\n
#line 241 "recordings.ecpp"

}
recItems.clear();
for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	if (!recItem->IsDir()) {
		recItems.push_back(recItem);
	}
}
if (currentSort == "dateasc")
	recItems.sort(RecordingsItemPtrCompare::ByAscendingDate);
else if (currentSort == "datedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingDate);
else if (currentSort == "namedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingName);
else
	recItems.sort(RecordingsItemPtrCompare::ByAscendingName);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
		RecordingsItemPtr recItem = *recIter;
		// xgettext:no-c-format
		string day(FormatDateTime(tr("%a,"), recItem->StartTime()));
		string dayLen(lexical_cast<string, int>(day.length() - 1) + ".25em;");
		// TRANSLATORS: recording duration format HH:MM
		string duration(recItem->Duration() < 0 ? "" : FormatDuration(tr("(%d:%02d)"), recItem->Duration() / 60, recItem->Duration() % 60));
		string shortDescr(recItem->RecInfo()->ShortText() ? recItem->RecInfo()->ShortText() : "");
		string description(recItem->RecInfo()->Description() ? recItem->RecInfo()->Description() : "");
		string hint(tr("Click to view details."));
		if (!shortDescr.empty()) hint = shortDescr + "<br />" + hint;
		else if (!description.empty()) hint = description + "<br />" + hint;
#ifdef HAVE_LIBPCRECPP
		pcrecpp::RE re(filter.c_str(), pcrecpp::UTF8());
		if (filter.empty() || re.PartialMatch(recItem->Name()) || re.PartialMatch(shortDescr) || re.PartialMatch(description))
#endif
		{

  reply.out() << data[26]; // \t<li class="recording">\n\t   
  // <& rec_item_file ...
  { 
#line 277 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "archived", tnt::toString((RecordingsManager::GetArchiveDescr(recItem->Recording())), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "day", tnt::toString((day), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "dayLen", tnt::toString((dayLen), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "duration", tnt::toString((duration), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "hint", tnt::toString((hint), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "id", tnt::toString((recItem->Id()), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "level", tnt::toString((recItem->Level()), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "name", tnt::toString((recItem->Name()), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "shortDescr", tnt::toString((shortDescr), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
    _tnt_cq8.add( "startTime", tnt::toString((recItem->StartTime()), reply.out().getloc() ) );
#line 277 "recordings.ecpp"
  main().rec_item_file(request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[27]; // \n\t</li>\n
#line 279 "recordings.ecpp"

		}
}

  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 288 "recordings.ecpp"
 { 
  reply.out() << data[30]; // <a href="recordings.html\?sort=name&filter=
#line 289 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << data[31]; // " alt="" />
#line 289 "recordings.ecpp"
  reply.sout() << ( tr("Sort by name") );
  reply.out() << data[32]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 291 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << data[33]; // " alt="" />
#line 291 "recordings.ecpp"
  reply.sout() << ( tr("Sort by date") );
  reply.out() << data[34]; // </a>\n
#line 292 "recordings.ecpp"

#ifdef HAVE_LIBPCRECPP

  reply.out() << data[35]; // <span class="sep">|</span>\n<span class="label bold">
#line 296 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << data[36]; // :&nbsp;<input type="text" name="filter" value="
#line 296 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << data[37]; // " id="filter" onchange="filterRecordings(this)" />&nbsp;
  // <& tooltip.help ...
  { 
#line 296 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 296 "recordings.ecpp"
    _tnt_cq9.add( "text", tnt::toString((tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")), reply.out().getloc() ) );
#line 296 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[38]; // </span>\n
#line 297 "recordings.ecpp"

#endif

  reply.out() << data[39]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 301 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << data[40]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 301 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 301 "recordings.ecpp"
    _tnt_cq10.add( "text", tnt::toString((tr("Expand all folders")), reply.out().getloc() ) );
#line 301 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[41]; // />\n<img onclick="CollapseAll()" src="
#line 302 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << data[42]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 302 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 302 "recordings.ecpp"
    _tnt_cq11.add( "text", tnt::toString((tr("Collapse all folders")), reply.out().getloc() ) );
#line 302 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[43]; // />\n<br />\n
#line 304 "recordings.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 313 "recordings.ecpp"
 { 
  reply.out() << data[46]; // <a href="recordings.html\?todel=
#line 313 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << data[47]; // " 
  // <& tooltip.hint ...
  { 
#line 313 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 313 "recordings.ecpp"
    _tnt_cq12.add( "text", tnt::toString((tr("Delete this recording from hard disc!")), reply.out().getloc() ) );
#line 313 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << data[48]; // ><img src="
#line 313 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[49]; // " alt="" /></a>
#line 313 "recordings.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 322 "recordings.ecpp"
 { 
  reply.out() << data[52]; // <a href="edit_recording.html\?recid=
#line 322 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << data[53]; // "><img src="
#line 322 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << data[54]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 322 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 322 "recordings.ecpp"
    _tnt_cq13.add( "text", tnt::toString((tr("Edit recording")), reply.out().getloc() ) );
#line 322 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << data[55]; //  /></a>
#line 322 "recordings.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
string title = tnt::stringTo<string>("title", "string", qparam.param("title"), reply.out().getloc());
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 333 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 333 "recordings.ecpp"
    _tnt_cq14.add( "action", tnt::toString("play_recording", reply.out().getloc() ) );
#line 333 "recordings.ecpp"
    _tnt_cq14.add( "alt", tnt::toString("", reply.out().getloc() ) );
#line 333 "recordings.ecpp"
    _tnt_cq14.add( "image", tnt::toString("play.png", reply.out().getloc() ) );
#line 333 "recordings.ecpp"
    _tnt_cq14.add( "param", tnt::toString((id), reply.out().getloc() ) );
#line 333 "recordings.ecpp"
    _tnt_cq14.add( "tip", tnt::toString((tr("play this recording.")), reply.out().getloc() ) );
#line 333 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << data[58]; // \n
  // <& pageelems.vlc_stream_recording ...
  { 
#line 334 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 334 "recordings.ecpp"
    _tnt_cq15.add( "recid", tnt::toString((id), reply.out().getloc() ) );
#line 334 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "vlc_stream_recording"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << data[59]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 335 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 335 "recordings.ecpp"
    _tnt_cq16.add( "title", tnt::toString((title), reply.out().getloc() ) );
#line 335 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << data[60]; // \n
  // <& recordings.edit_rec ...
  { 
#line 336 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 336 "recordings.ecpp"
    _tnt_cq17.add( "id", tnt::toString((id), reply.out().getloc() ) );
#line 336 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << data[61]; // \n
  // <& recordings.del_rec ...
  { 
#line 337 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 337 "recordings.ecpp"
    _tnt_cq18.add( "id", tnt::toString((id), reply.out().getloc() ) );
#line 337 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << data[62]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string archived = tnt::stringTo<string>("archived", "string", qparam.param("archived"), reply.out().getloc());
string title = tnt::stringTo<string>("title", "string", qparam.param("title"), reply.out().getloc());
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[65]; // <img src="
#line 347 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << data[66]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 347 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 347 "recordings.ecpp"
    _tnt_cq19.add( "text", tnt::toString((archived), reply.out().getloc() ) );
#line 347 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << data[67]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 348 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 348 "recordings.ecpp"
    _tnt_cq20.add( "title", tnt::toString((title), reply.out().getloc() ) );
#line 348 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << data[68]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::rec_item_dir_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_dir " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string name = tnt::stringTo<string>("name", "string", qparam.param("name"), reply.out().getloc());
int level = tnt::stringTo<int>("level", "int", qparam.param("level"), reply.out().getloc());
string collapseimg = qparam.has("collapseimg") ? tnt::stringToWithDefault<string>(qparam.param("collapseimg"), ( "plus.png"), reply.out().getloc()) : ( "plus.png");
string folderimg = qparam.has("folderimg") ? tnt::stringToWithDefault<string>(qparam.param("folderimg"), ( "folder_closed.png"), reply.out().getloc()) : ( "folder_closed.png");
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[71]; // \t<div class="recording_item" onclick="Toggle(this)">\n\t\t<div class="recording_imgs">
#line 361 "recordings.ecpp"
 reply.out() << StringRepeat(level - 1, "<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); 
  reply.out() << data[72]; // <img class="recording_expander" src="
#line 361 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", collapseimg) );
  reply.out() << data[73]; // " alt="" /><img class="recording_folder" src="
#line 361 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", folderimg) );
  reply.out() << data[74]; // " alt="" /></div>\n\t\t<div class="recording_spec">\n\t\t\t<div class="recording_name">
#line 363 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << data[75]; // </div>\n\t    </div>\n\t\t<div class="recording_actions">&nbsp;</div>\n\t</div>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::rec_item_file_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_file " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string name = tnt::stringTo<string>("name", "string", qparam.param("name"), reply.out().getloc());
int level = tnt::stringTo<int>("level", "int", qparam.param("level"), reply.out().getloc());
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
string day = tnt::stringTo<string>("day", "string", qparam.param("day"), reply.out().getloc());
string dayLen = tnt::stringTo<string>("dayLen", "string", qparam.param("dayLen"), reply.out().getloc());
time_t startTime = tnt::stringTo<time_t>("startTime", "time_t", qparam.param("startTime"), reply.out().getloc());
string duration = tnt::stringTo<string>("duration", "string", qparam.param("duration"), reply.out().getloc());
string hint = tnt::stringTo<string>("hint", "string", qparam.param("hint"), reply.out().getloc());
string shortDescr = tnt::stringTo<string>("shortDescr", "string", qparam.param("shortDescr"), reply.out().getloc());
string archived = tnt::stringTo<string>("archived", "string", qparam.param("archived"), reply.out().getloc());
  // </%args>

#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[78]; // \t<div class="recording_item">\n\t<div class="recording_imgs">
#line 385 "recordings.ecpp"
 reply.out() << StringRepeat(level, "<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); 
#line 385 "recordings.ecpp"
 if (!archived.empty()) { 
  reply.out() << data[79]; // <img src="
#line 385 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << data[80]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 385 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 385 "recordings.ecpp"
    _tnt_cq21.add( "text", tnt::toString((archived), reply.out().getloc() ) );
#line 385 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << data[81]; //  />
#line 385 "recordings.ecpp"
 } else { 
  reply.out() << data[82]; // <input type="checkbox" name="deletions" value="
#line 385 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << data[83]; // " />
#line 385 "recordings.ecpp"
 } 
  reply.out() << data[84]; // </div>\n\t<div class="recording_spec">\n\t\t<div class="recording_day">
#line 387 "recordings.ecpp"
  reply.sout() << ( FormatDateTime(tr("%a,"), startTime) + string(" ") + FormatDateTime(tr("%b %d %y"), startTime) + string(" ") + FormatDateTime(tr("%I:%M %p"), startTime) );
  reply.out() << data[85]; // </div>\n\t\t<div class="recording_duration">
#line 388 "recordings.ecpp"
  reply.sout() << ( duration );
  reply.out() << data[86]; // </div>\n\t\t<div class="recording_name"><a 
  // <& tooltip.hint ...
  { 
#line 389 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 389 "recordings.ecpp"
    _tnt_cq22.add( "text", tnt::toString((hint), reply.out().getloc() ) );
#line 389 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 389 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 389 "recordings.ecpp"
    _tnt_cq23.add( "domId", tnt::toString((id), reply.out().getloc() ) );
#line 389 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << data[87]; // >
#line 389 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << data[88]; // <br />
#line 389 "recordings.ecpp"
if ((name != shortDescr) && (!shortDescr.empty())) {
  reply.out() << data[89]; // <span>
#line 389 "recordings.ecpp"
  reply.sout() << ( shortDescr );
  reply.out() << data[90]; // </span>
#line 389 "recordings.ecpp"
 } else { 
  reply.out() << data[91]; // <span>&nbsp;</span>
#line 389 "recordings.ecpp"
 } 
  reply.out() << data[92]; // </a></div>\n\t</div>\n\t<div class="recording_actions">\n
#line 392 "recordings.ecpp"

		if (archived.empty()) {

  reply.out() << data[93]; // \t\t
  // <& recordings.rec_tools ...
  { 
#line 395 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 395 "recordings.ecpp"
    _tnt_cq24.add( "id", tnt::toString((id), reply.out().getloc() ) );
#line 395 "recordings.ecpp"
    _tnt_cq24.add( "title", tnt::toString((name), reply.out().getloc() ) );
#line 395 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "rec_tools"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << data[94]; // \n
#line 396 "recordings.ecpp"

		}
		else {

  reply.out() << data[95]; // \t\t<img src="img/transparent.png" alt="" width="16px" height="16px" />\n\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 401 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 401 "recordings.ecpp"
    _tnt_cq25.add( "title", tnt::toString((name), reply.out().getloc() ) );
#line 401 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << data[96]; // \n
#line 402 "recordings.ecpp"

		}

  reply.out() << data[97]; // \t</div>\n
#line 406 "recordings.ecpp"

	if (! archived.empty()) {

  reply.out() << data[98]; // \t<div class="recording_arch">
#line 409 "recordings.ecpp"
  reply.sout() << ( archived );
  reply.out() << data[99]; // </div>\n
#line 410 "recordings.ecpp"

	}

  reply.out() << data[100]; // \t</div>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 33 "recordings.ecpp"
  typedef string currentSort_type;
  TNT_REQUEST_PAGE_VAR(currentSort_type, currentSort, "string currentSort", ());   // <%request> string currentSort
#line 34 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 35 "recordings.ecpp"
  typedef string currentFilter_type;
  TNT_REQUEST_PAGE_VAR(currentFilter_type, currentFilter, "string currentFilter", ());   // <%request> string currentFilter
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 419 "recordings.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 419 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << data[103]; // \n
#line 420 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
