////////////////////////////////////////////////////////////////////////
// remote.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.remote")

// <%pre>
#line 1 "remote.ecpp"


#include <grab.h>
#include <setup.h>
#include <tools.h>
#include <users.h>

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class remote_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        remote_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    remote_actions_type remote_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("remote");

static const char* rawData = "\360\000\000\000\361\000\000\000\025\001\000\000 \001\000\000#\001\000\0006\013\000\000g"
  "\013\000\000\231\013\000\000\311\013\000\000\364\013\000\0009\014\000\000\347\014\000\000\005\016\000\000\316\020\000"
  "\000\n\021\000\0004\021\000\0007\021\000\000{\021\000\000\255\021\000\000\347\021\000\000\237\022\000\000\375\022\000"
  "\000[\023\000\000\273\023\000\000\031\024\000\000w\024\000\000\327\024\000\0008\025\000\000\230\025\000\000\372\025"
  "\000\000Z\026\000\000\273\026\000\000\034\027\000\000|\027\000\000\334\027\000\000<\030\000\000\237\030\000\000%\031"
  "\000\000\272\031\000\000>\032\000\000\304\032\000\000e\033\000\000\023\034\000\000\267\034\000\000R\035\000\000\261"
  "\035\000\000\023\036\000\000w\036\000\000\335\036\000\000B\037\000\000{\037\000\000|\037\000\000}\037\000\000\200\037"
  "\000\000\214\037\000\000\014 \000\000\217 \000\000\222 \000\000\234!\000\000\245!\000\000\n\n<html>\n\t<head>\n\t\t<t"
  "itle>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\"><!--\n\t\tvar newImg = null;\n\t\tvar imgs"
  "rc = \"\";\n\t\tvar osdAjax = null;\n\t\tvar osdTimeout = -1;\n\t\tvar interval = -1;\n\t\tvar clkTimer;\n\n\t\tfunct"
  "ion changeScreenContent(){\n\t\t\tvar screenCon= document.getElementsByName('screenCon');\n\t\t\tfor ( var i=0; i < s"
  "creenCon.length; i++){\n\t\t\t\tif (screenCon[i].id == 'screenCon_grab'){\n\t\t\t\t\tif (screenCon[i].checked){\n\t\t"
  "\t\t\t\tnewImg = new Image();\n\t\t\t\t\t\tStreamLoad();\n\t\t\t\t\t\tChangeInterval();\n\t\t\t\t\t\tStreamLoad();\n"
  "\t\t\t\t\t\tdocument.images.vdrlive.style.display= '';\n\t\t\t\t\t} else {\n\t\t\t\t\t\twindow.clearInterval(interval"
  ");\n\t\t\t\t\t\tdocument.images.vdrlive.style.display= 'none';\n\t\t\t\t\t\tnewImg = null;\n\t\t\t\t\t}\n\t\t\t\t} el"
  "se if (screenCon[i].id == 'screenCon_osd'){\n\t\t\t\t\tif (screenCon[i].checked){\n\t\t\t\t\t\tosdAjax= new Ajax('osd"
  ".xml', {method: 'get'});\n\t\t\t\t\t\tosdAjax.lastUpd= -1;\n\t\t\t\t\t\tosdAjax.addEvent('onComplete', function(text,"
  "xmlDoc){\n\t\t\t\t\t\t\ttry{\n\t\t\t\t\t\t\t\tvar upd= parseInt(xmlDoc.firstChild.getAttribute(\"data-time\"),10);\n"
  "\t\t\t\t\t\t\t\tif ( osdAjax.lastUpd != upd ){\n\t\t\t\t\t\t\t\t\t$('osd').empty().setHTML(text);\n\t\t\t\t\t\t\t\t\t"
  "osdAjax.lastUpd = upd;\n\t\t\t\t\t\t\t\t\t$$('#screenshot .osdItems')[0].scrollTop= $$('#screenshot .selected')[0].of"
  "fsetTop - 40;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t} catch (e) {}\n\t\t\t\t\t\t\twindow.clearInterval(osdTimeout);\n\t\t"
  "\t\t\t\t\tosdTimeout= window.setTimeout(\"OSDLoad()\",1000);\n\t\t\t\t\t\t});\n\t\t\t\t\t\t$('osd').style.display= ''"
  ";\n\n\t\t\t\t\t\tOSDLoad()\n\t\t\t\t\t} else {\n\t\t\t\t\t\t$('osd').style.display= 'none';\n\t\t\t\t\t\tosdAjax= nul"
  "l;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\n\t\t}\n\n\t\tfunction StreamLoad()\n\t\t{\n\t\t\tif (!newImg)\n\t\t\t\treturn;"
  "\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tdocument.images.vdrlive.src=newImg.src;\n\t\t\tnewImg"
  ".src=imgsrc+\"\?\"+uniq;\n\t\t}\n\n\t\tfunction StreamInit()\n\t\t{\n\t\t\tdocument.getElementsByName('screenCon')[0]"
  ".checked= true;\n\t\t\tif (document.images.vdrlive)\n\t\t\t\timgsrc = document.images.vdrlive.src;\n\t\t\tFillInterva"
  "ls();\n\t\t\tchangeScreenContent();\n\t\t\t$('osd').addEvents({\n\t\t\t    'click': function(ev){\n\t\t\t        $cle"
  "ar(clkTimer);\n\t\t\t        clkTimer = (function(){\n\t\t\t        \thandleOSD(ev.target, false);\n\t\t\t        })."
  "delay(200, this);\n\t\t\t    },\n\t\t\t    'dblclick': function(ev){\n\t\t\t        $clear(clkTimer);\n\t\t\t        "
  "handleOSD(ev.target, true);\n\t\t\t    }\n\t\t\t});\n\n\t\t}\n\n\t\tfunction ChangeInterval()\n\t\t{\n\t\t\tvar eleme"
  "nt = document.getElementsByName('interval').item(0);\n\t\t\tvar timeout = element.value;\n\t\t\twindow.clearInterval("
  "interval);\n\t\t\tinterval = window.setInterval(\"StreamLoad()\", timeout);\n\t\t}\n\n\t\tfunction OSDLoad(){\n\t\t\t"
  "if (osdAjax)\n\t\t\t\tosdAjax.request();\n\t\t}\n\t\tfunction handleOSD(elem, doEnter){\n\t\t\tswitch (elem.className"
  "){\n\t\t\tcase 'osdButtonRed':\n\t\t\t\treturn KeyPress();\n\t\t\tcase 'osdButtonGreen':\n\t\t\t\treturn KeyPress();"
  "\n\t\t\tcase 'osdButtonYellow':\n\t\t\t\treturn KeyPress();\n\t\t\tcase 'osdButtonBlue':\n\t\t\t\treturn KeyPress();"
  "\n\t\t\tcase 'osdTitle':\n\t\t\t\treturn KeyPress();\n\t\t\tcase 'osdItem':\n\t\t\t\tvar hits= 0,\n\t\t\t\t\tcur= ele"
  "m,\n\t\t\t\t\tkeycode= ;\n\t\t\t\twhile (cur && cur.className.indexOf('selected') == -1 ){\n\t\t\t\t\tcur= cur.previo"
  "usSibling;\n\t\t\t\t\thits++;\n\t\t\t\t};\n\t\t\t\tif ( !cur){\n\t\t\t\t\thits= 0;\n\t\t\t\t\tcur= elem;\n\t\t\t\t\tk"
  "eycode= ;\n\t\t\t\t\twhile (cur && cur.className.indexOf('selected') == -1 ){\n\t\t\t\t\t\tcur= cur.nextSibling;\n\t"
  "\t\t\t\t\thits++;\n\t\t\t\t\t};\n\t\t\t\t}\n\t\t\t\tfor(;hits > 0; hits--)\n\t\t\t\t\tKeyPress(keycode, true);\n\t\t"
  "\t\tif ( !doEnter){\n\t\t\t\t\tOSDLoad();\n\t\t\t\t\treturn false;\n\t\t\t\t}\n\t\t\tcase 'osdItem selected':\n\t\t\t"
  "\treturn KeyPress();\n\t\t\t}\n\t\t\treturn true;\n\t\t}\n\n\t\tfunction KeyPress(keycode,DonotLoadOSD)\n\t\t{\n//\t"
  "\t\tLiveSimpleAjaxRequest('keypress.xml', 'keycode', keycode);\n\t\t\tvar req = new Ajax('keypress.xml', { method : '"
  "post'});\n\t\t\tif (!DonotLoadOSD && osdAjax)\n\t\t\t\treq.addEvent('onComplete', OSDLoad);\n\t\t\treq.request('keyco"
  "de=' + keycode + '&async=1');\n\t\t\treturn false;\n\t\t}\n\n\t\tfunction FillIntervals()\n\t\t{\n\t\t\tvar element ="
  " document.getElementsByName('interval').item(0);\n\t\t\tif (!element)\n\t\t\t\treturn;\n\t\t\tvar items = new Array(1"
  "000, 2000, 5000);\n\t\t\telement.options.length = items.length;\n\t\t\tfor (i = 0; i < items.length; ++i) {\n\t\t\t\t"
  "element.options[i].value = items[i];\n\t\t\t\telement.options[i].text = (items[i] / 1000) + \" s\";\n\t\t\t\tif (item"
  "s[i] == )\n\t\t\t\t\telement.selectedIndex = i;\n\t\t\t}\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"Stre"
  "amInit();\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<div class=\"screenshot\" id=\"screenshot\">\n\n\t\t\t\t"
  "\t<img src=\"screenshot.jpg\" name=\"vdrlive\" />\n\n\t\t\t\t<div id=\"osd\"></div>\n\t\t\t</div>\n\t\t\t<div>\n\t\t"
  "\t<img src=\"\" width=\"162\" height=\"378\" border=\"0\" usemap=\"#remote\" alt=\"\" />\n\t\t\t     <map name=\"remo"
  "te\">\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,36,10\" alt=\"Power\" onclick=\"return KeyPress()\" />"
  "\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"27,60,59,75\" alt=\"1\" onclick=\"return KeyPress()\" />\n\t\t\t"
  "\t  <area href=\"#\" shape=\"rect\" coords=\"64,59,98,75\" alt=\"2\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <are"
  "a href=\"#\" shape=\"rect\" coords=\"103,59,137,75\" alt=\"3\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href"
  "=\"#\" shape=\"rect\" coords=\"25,82,60,98\" alt=\"4\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" s"
  "hape=\"rect\" coords=\"65,82,98,99\" alt=\"5\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"r"
  "ect\" coords=\"103,83,137,99\" alt=\"6\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" "
  "coords=\"26,106,60,121\" alt=\"7\"  onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coord"
  "s=\"65,105,97,121\" alt=\"8\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"10"
  "4,106,137,122\" alt=\"9\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"66,128"
  ",98,144\" alt=\"0\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,157,13"
  "\" alt=\"Vol+\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,190,13\" al"
  "t=\"Vol-\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"125,157,13\" alt=\""
  "P+\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"125,190,13\" alt=\"P-\" o"
  "nclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"81,174,8\" alt=\"Mute\" onclick"
  "=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"81,202,11\" alt=\"Record\" onclick=\""
  "return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"39,215,29,227,30,235,39,236,51,222,49,215,"
  "43,213\" alt=\"Menu\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"119,213,12"
  "7,219,135,230,132,235,127,236,119,231,114,223,113,215\" alt=\"Exit\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <are"
  "a href=\"#\" shape=\"poly\" coords=\"33,289,31,298,43,310,51,308,54,300,41,287\" alt=\"Subtitles\" onclick=\"return K"
  "eyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"131,289,133,298,122,310,112,308,110,300,122,287\" "
  "alt=\"Audio\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"58,230,70,223,82,2"
  "23,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,232\" alt=\"Up\" onclick=\"return KeyPress()\" />\n\t\t\t\t  "
  "<area href=\"#\" shape=\"poly\" coords=\"111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,"
  "253,101,245\" alt=\"Right\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"66,2"
  "81,75,285,86,285,95,281,106,291,100,295,87,300,73,300,58,291,57,289,58,289\" alt=\"Down\" onclick=\"return KeyPress()"
  "\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,"
  "252,49,240\" alt=\"Left\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"81,2"
  "61,17\" alt=\"Ok\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"25,324,52,339"
  "\" alt=\"Red\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"53,324,81,339\" a"
  "lt=\"Green\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"83,324,109,339\" al"
  "t=\"Yellow\" onclick=\"return KeyPress()\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"110,324,137,339\" a"
  "lt=\"Blue\" onclick=\"return KeyPress()\" />\n\t\t\t     </map>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n\n\n<b"
  "></b>:&nbsp;\n\n\t <input type=\"radio\" name=\"screenCon\" id=\"screenCon_grab\" onchange=\"changeScreenContent()\"/"
  ">&nbsp;<label for=\"screenCon_grab\">:</label> <select name=\"interval\" onchange=\"ChangeInterval()\"></select>&nbsp"
  ";&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; -\n\n <input type=\"radio\" name=\"screenCon\" id=\"screenCon"
  "_osd\" onchange=\"changeScreenContent()\" />&nbsp;<label for=\"screenCon_osd\">OSD</label> -\n <input type=\"radio\" "
  "name=\"screenCon\" id=\"screenCon_none\" onchange=\"changeScreenContent()\" />&nbsp;<label for=\"screenCon_osd\"></la"
  "bel>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    remote_actions(*this, "remote_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
int channel = qparam.has("channel") ? tnt::stringToWithDefault<int>(qparam.param("channel"), ( -1), reply.out().getloc()) : ( -1);
  // </%args>

#line 16 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 19 "remote.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 22 "remote.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << data[0]; // \n
#line 25 "remote.ecpp"

	if (!cUser::CurrentUserHasRightTo(UR_USEREMOTE))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	pageTitle = tr("Remote Control");

#if VDRVERSNUM >= 20301
	LOCK_CHANNELS_READ;
#else
	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );
#endif

	// cChannel* Channel; (see %request above)
	if ( channel > 0 ) {
#if VDRVERSNUM >= 20301
		Channel = (cChannel *)Channels->GetByNumber( channel );
#else
		Channel = Channels.GetByNumber( channel );
#endif
	}
	else {
		if (cDevice::CurrentChannel()) {
#if VDRVERSNUM >= 20301
			Channel = (cChannel *)Channels->GetByNumber(cDevice::CurrentChannel());
#else
			Channel = Channels.GetByNumber(cDevice::CurrentChannel());
#endif
		}
		else {
#if VDRVERSNUM >= 20301
			Channel = (cChannel *)Channels->Get( Channels->GetNextNormal( -1 ) );
#else
			Channel = Channels.Get( Channels.GetNextNormal( -1 ) );
#endif
		}
	}
	if ( Channel == 0 )
		throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );


  // <& pageelems.doc_type ...
  { 
#line 67 "remote.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 67 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 70 "remote.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 71 "remote.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 71 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 72 "remote.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 72 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n\t\t<script type="text/javascript"><!--\n\t\tvar newImg = null;\n\t\tvar imgsrc = "";\n\t\tvar osdAjax = null;\n\t\tvar osdTimeout = -1;\n\t\tvar interval = -1;\n\t\tvar clkTimer;\n\n\t\tfunction changeScreenContent(){\n\t\t\tvar screenCon= document.getElementsByName('screenCon');\n\t\t\tfor ( var i=0; i < screenCon.length; i++){\n\t\t\t\tif (screenCon[i].id == 'screenCon_grab'){\n\t\t\t\t\tif (screenCon[i].checked){\n\t\t\t\t\t\tnewImg = new Image();\n\t\t\t\t\t\tStreamLoad();\n\t\t\t\t\t\tChangeInterval();\n\t\t\t\t\t\tStreamLoad();\n\t\t\t\t\t\tdocument.images.vdrlive.style.display= '';\n\t\t\t\t\t} else {\n\t\t\t\t\t\twindow.clearInterval(interval);\n\t\t\t\t\t\tdocument.images.vdrlive.style.display= 'none';\n\t\t\t\t\t\tnewImg = null;\n\t\t\t\t\t}\n\t\t\t\t} else if (screenCon[i].id == 'screenCon_osd'){\n\t\t\t\t\tif (screenCon[i].checked){\n\t\t\t\t\t\tosdAjax= new Ajax('osd.xml', {method: 'get'});\n\t\t\t\t\t\tosdAjax.lastUpd= -1;\n\t\t\t\t\t\tosdAjax.addEvent('onComplete', function(text,xmlDoc){\n\t\t\t\t\t\t\ttry{\n\t\t\t\t\t\t\t\tvar upd= parseInt(xmlDoc.firstChild.getAttribute("data-time"),10);\n\t\t\t\t\t\t\t\tif ( osdAjax.lastUpd != upd ){\n\t\t\t\t\t\t\t\t\t$('osd').empty().setHTML(text);\n\t\t\t\t\t\t\t\t\tosdAjax.lastUpd = upd;\n\t\t\t\t\t\t\t\t\t$$('#screenshot .osdItems')[0].scrollTop= $$('#screenshot .selected')[0].offsetTop - 40;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t} catch (e) {}\n\t\t\t\t\t\t\twindow.clearInterval(osdTimeout);\n\t\t\t\t\t\t\tosdTimeout= window.setTimeout("OSDLoad()",1000);\n\t\t\t\t\t\t});\n\t\t\t\t\t\t$('osd').style.display= '';\n\n\t\t\t\t\t\tOSDLoad()\n\t\t\t\t\t} else {\n\t\t\t\t\t\t$('osd').style.display= 'none';\n\t\t\t\t\t\tosdAjax= null;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\n\t\t}\n\n\t\tfunction StreamLoad()\n\t\t{\n\t\t\tif (!newImg)\n\t\t\t\treturn;\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tdocument.images.vdrlive.src=newImg.src;\n\t\t\tnewImg.src=imgsrc+"\?"+uniq;\n\t\t}\n\n\t\tfunction StreamInit()\n\t\t{\n\t\t\tdocument.getElementsByName('screenCon')[0].checked= true;\n\t\t\tif (document.images.vdrlive)\n\t\t\t\timgsrc = document.images.vdrlive.src;\n\t\t\tFillIntervals();\n\t\t\tchangeScreenContent();\n\t\t\t$('osd').addEvents({\n\t\t\t    'click': function(ev){\n\t\t\t        $clear(clkTimer);\n\t\t\t        clkTimer = (function(){\n\t\t\t        \thandleOSD(ev.target, false);\n\t\t\t        }).delay(200, this);\n\t\t\t    },\n\t\t\t    'dblclick': function(ev){\n\t\t\t        $clear(clkTimer);\n\t\t\t        handleOSD(ev.target, true);\n\t\t\t    }\n\t\t\t});\n\n\t\t}\n\n\t\tfunction ChangeInterval()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar timeout = element.value;\n\t\t\twindow.clearInterval(interval);\n\t\t\tinterval = window.setInterval("StreamLoad()", timeout);\n\t\t}\n\n\t\tfunction OSDLoad(){\n\t\t\tif (osdAjax)\n\t\t\t\tosdAjax.request();\n\t\t}\n\t\tfunction handleOSD(elem, doEnter){\n\t\t\tswitch (elem.className){\n\t\t\tcase 'osdButtonRed':\n\t\t\t\treturn KeyPress(
#line 171 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << data[5]; // );\n\t\t\tcase 'osdButtonGreen':\n\t\t\t\treturn KeyPress(
#line 173 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << data[6]; // );\n\t\t\tcase 'osdButtonYellow':\n\t\t\t\treturn KeyPress(
#line 175 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << data[7]; // );\n\t\t\tcase 'osdButtonBlue':\n\t\t\t\treturn KeyPress(
#line 177 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << data[8]; // );\n\t\t\tcase 'osdTitle':\n\t\t\t\treturn KeyPress(
#line 179 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << data[9]; // );\n\t\t\tcase 'osdItem':\n\t\t\t\tvar hits= 0,\n\t\t\t\t\tcur= elem,\n\t\t\t\t\tkeycode= 
#line 183 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << data[10]; // ;\n\t\t\t\twhile (cur && cur.className.indexOf('selected') == -1 ){\n\t\t\t\t\tcur= cur.previousSibling;\n\t\t\t\t\thits++;\n\t\t\t\t};\n\t\t\t\tif ( !cur){\n\t\t\t\t\thits= 0;\n\t\t\t\t\tcur= elem;\n\t\t\t\t\tkeycode= 
#line 191 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << data[11]; // ;\n\t\t\t\t\twhile (cur && cur.className.indexOf('selected') == -1 ){\n\t\t\t\t\t\tcur= cur.nextSibling;\n\t\t\t\t\t\thits++;\n\t\t\t\t\t};\n\t\t\t\t}\n\t\t\t\tfor(;hits > 0; hits--)\n\t\t\t\t\tKeyPress(keycode, true);\n\t\t\t\tif ( !doEnter){\n\t\t\t\t\tOSDLoad();\n\t\t\t\t\treturn false;\n\t\t\t\t}\n\t\t\tcase 'osdItem selected':\n\t\t\t\treturn KeyPress(
#line 204 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << data[12]; // );\n\t\t\t}\n\t\t\treturn true;\n\t\t}\n\n\t\tfunction KeyPress(keycode,DonotLoadOSD)\n\t\t{\n//\t\t\tLiveSimpleAjaxRequest('keypress.xml', 'keycode', keycode);\n\t\t\tvar req = new Ajax('keypress.xml', { method : 'post'});\n\t\t\tif (!DonotLoadOSD && osdAjax)\n\t\t\t\treq.addEvent('onComplete', OSDLoad);\n\t\t\treq.request('keycode=' + keycode + '&async=1');\n\t\t\treturn false;\n\t\t}\n\n\t\tfunction FillIntervals()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tif (!element)\n\t\t\t\treturn;\n\t\t\tvar items = new Array(1000, 2000, 5000);\n\t\t\telement.options.length = items.length;\n\t\t\tfor (i = 0; i < items.length; ++i) {\n\t\t\t\telement.options[i].value = items[i];\n\t\t\t\telement.options[i].text = (items[i] / 1000) + " s";\n\t\t\t\tif (items[i] == 
#line 229 "remote.ecpp"
  reply.sout() << ( ConvertToString( LiveSetup().GetScreenshotInterval(), locale("C") ) );
  reply.out() << data[13]; // )\n\t\t\t\t\telement.selectedIndex = i;\n\t\t\t}\n\t\t}\n\t\t//--></script>\n
#line 234 "remote.ecpp"
 reply.sout().imbue(locale());

  reply.out() << data[14]; // \t</head>\n\t<body onload="StreamInit();">\n\t\t
  // <& pageelems.logo ...
  { 
#line 237 "remote.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 237 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[15]; // \n\t\t
  // <& menu ...
  { 
#line 238 "remote.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 238 "remote.ecpp"
    _tnt_cq4.add( "active", tnt::toString("remote", reply.out().getloc() ) );
#line 238 "remote.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("remote.remote_actions"), reply.out().getloc() ) );
#line 238 "remote.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[16]; // \n\t\t<div class="inhalt">\n\t\t\t<div class="screenshot" id="screenshot">\n
#line 241 "remote.ecpp"
				if (LiveGrabImageManager().CanGrab()) {	
  reply.out() << data[17]; // \n\t\t\t\t\t<img src="screenshot.jpg" name="vdrlive" />\n
#line 243 "remote.ecpp"
				}											
  reply.out() << data[18]; // \n\t\t\t\t<div id="osd"></div>\n\t\t\t</div>\n\t\t\t<div>\n\t\t\t<img src="
#line 247 "remote.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "remotecontrol.jpg") );
  reply.out() << data[19]; // " width="162" height="378" border="0" usemap="#remote" alt="" />\n\t\t\t     <map name="remote">\n\t\t\t\t  <area href="#" shape="circle" coords="37,36,10" alt="Power" onclick="return KeyPress(
#line 249 "remote.ecpp"
  reply.sout() << ( kPower );
  reply.out() << data[20]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="27,60,59,75" alt="1" onclick="return KeyPress(
#line 250 "remote.ecpp"
  reply.sout() << ( k1 );
  reply.out() << data[21]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="64,59,98,75" alt="2" onclick="return KeyPress(
#line 251 "remote.ecpp"
  reply.sout() << ( k2 );
  reply.out() << data[22]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="103,59,137,75" alt="3" onclick="return KeyPress(
#line 252 "remote.ecpp"
  reply.sout() << ( k3 );
  reply.out() << data[23]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="25,82,60,98" alt="4" onclick="return KeyPress(
#line 253 "remote.ecpp"
  reply.sout() << ( k4 );
  reply.out() << data[24]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="65,82,98,99" alt="5" onclick="return KeyPress(
#line 254 "remote.ecpp"
  reply.sout() << ( k5 );
  reply.out() << data[25]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="103,83,137,99" alt="6" onclick="return KeyPress(
#line 255 "remote.ecpp"
  reply.sout() << ( k6 );
  reply.out() << data[26]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="26,106,60,121" alt="7"  onclick="return KeyPress(
#line 256 "remote.ecpp"
  reply.sout() << ( k7 );
  reply.out() << data[27]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="65,105,97,121" alt="8" onclick="return KeyPress(
#line 257 "remote.ecpp"
  reply.sout() << ( k8 );
  reply.out() << data[28]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="104,106,137,122" alt="9" onclick="return KeyPress(
#line 258 "remote.ecpp"
  reply.sout() << ( k9 );
  reply.out() << data[29]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="66,128,98,144" alt="0" onclick="return KeyPress(
#line 259 "remote.ecpp"
  reply.sout() << ( k0 );
  reply.out() << data[30]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="37,157,13" alt="Vol+" onclick="return KeyPress(
#line 260 "remote.ecpp"
  reply.sout() << ( kVolUp );
  reply.out() << data[31]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="37,190,13" alt="Vol-" onclick="return KeyPress(
#line 261 "remote.ecpp"
  reply.sout() << ( kVolDn );
  reply.out() << data[32]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="125,157,13" alt="P+" onclick="return KeyPress(
#line 262 "remote.ecpp"
  reply.sout() << ( kChanUp );
  reply.out() << data[33]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="125,190,13" alt="P-" onclick="return KeyPress(
#line 263 "remote.ecpp"
  reply.sout() << ( kChanDn );
  reply.out() << data[34]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,174,8" alt="Mute" onclick="return KeyPress(
#line 264 "remote.ecpp"
  reply.sout() << ( kMute );
  reply.out() << data[35]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,202,11" alt="Record" onclick="return KeyPress(
#line 265 "remote.ecpp"
  reply.sout() << ( kRecord );
  reply.out() << data[36]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="39,215,29,227,30,235,39,236,51,222,49,215,43,213" alt="Menu" onclick="return KeyPress(
#line 266 "remote.ecpp"
  reply.sout() << ( kMenu );
  reply.out() << data[37]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="119,213,127,219,135,230,132,235,127,236,119,231,114,223,113,215" alt="Exit" onclick="return KeyPress(
#line 267 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << data[38]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="33,289,31,298,43,310,51,308,54,300,41,287" alt="Subtitles" onclick="return KeyPress(
#line 268 "remote.ecpp"
  reply.sout() << ( kSubtitles );
  reply.out() << data[39]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="131,289,133,298,122,310,112,308,110,300,122,287" alt="Audio" onclick="return KeyPress(
#line 269 "remote.ecpp"
  reply.sout() << ( kAudio );
  reply.out() << data[40]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="58,230,70,223,82,223,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,232" alt="Up" onclick="return KeyPress(
#line 270 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << data[41]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245" alt="Right" onclick="return KeyPress(
#line 271 "remote.ecpp"
  reply.sout() << ( kRight );
  reply.out() << data[42]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="66,281,75,285,86,285,95,281,106,291,100,295,87,300,73,300,58,291,57,289,58,289" alt="Down" onclick="return KeyPress(
#line 272 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << data[43]; // )" />\n\t\t\t\t  <area href="#" shape="poly" coords="51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,252,49,240" alt="Left" onclick="return KeyPress(
#line 273 "remote.ecpp"
  reply.sout() << ( kLeft );
  reply.out() << data[44]; // )" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,261,17" alt="Ok" onclick="return KeyPress(
#line 274 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << data[45]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="25,324,52,339" alt="Red" onclick="return KeyPress(
#line 275 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << data[46]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="53,324,81,339" alt="Green" onclick="return KeyPress(
#line 276 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << data[47]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="83,324,109,339" alt="Yellow" onclick="return KeyPress(
#line 277 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << data[48]; // )" />\n\t\t\t\t  <area href="#" shape="rect" coords="110,324,137,339" alt="Blue" onclick="return KeyPress(
#line 278 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << data[49]; // )" />\n\t\t\t     </map>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[50]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[51]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::remote_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote::remote_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 19 "remote.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 16 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[52]; // <b>
#line 287 "remote.ecpp"
  reply.sout() << ( tr("Selection") );
  reply.out() << data[53]; // </b>:&nbsp;\n
#line 288 "remote.ecpp"
	if ( LiveGrabImageManager().CanGrab()) {			
  reply.out() << data[54]; // \n\t <input type="radio" name="screenCon" id="screenCon_grab" onchange="changeScreenContent()"/>&nbsp;<label for="screenCon_grab">
#line 289 "remote.ecpp"
  reply.sout() << ( tr("Snapshot interval") );
  reply.out() << data[55]; // :</label> <select name="interval" onchange="ChangeInterval()"></select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
  // <& pageelems.vlc_stream_channel ...
  { 
#line 289 "remote.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 289 "remote.ecpp"
    _tnt_cq5.add( "channelId", tnt::toString((Channel->GetChannelID()), reply.out().getloc() ) );
#line 289 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "vlc_stream_channel"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[56]; //  -\n
#line 290 "remote.ecpp"
	} 				
  reply.out() << data[57]; // \n <input type="radio" name="screenCon" id="screenCon_osd" onchange="changeScreenContent()" />&nbsp;<label for="screenCon_osd">OSD</label> -\n <input type="radio" name="screenCon" id="screenCon_none" onchange="changeScreenContent()" />&nbsp;<label for="screenCon_osd">
#line 292 "remote.ecpp"
  reply.sout() << ( tr("Stop") );
  reply.out() << data[58]; // </label>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
