////////////////////////////////////////////////////////////////////////
// searchresults.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.searchresults")

// <%pre>
#line 1 "searchresults.ecpp"


#include <epgsearch.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("searchresults");

static const char* rawData = "x\000\000\000\234\000\000\000\247\000\000\000\252\000\000\000\276\000\000\000\301\000\000"
  "\000\331\000\000\000\335\000\000\000\336\000\000\000\031\001\000\000U\001\000\000\243\001\000\000\306\001\000\000\360"
  "\001\000\000\362\001\000\000\024\002\000\000M\002\000\000O\002\000\000{\002\000\000\234\002\000\000\237\002\000\000"
  "\320\002\000\000\362\002\000\000\007\003\000\000(\003\000\000.\003\000\000P\003\000\000w\003\000\000x\003\000\000z"
  "\003\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div"
  " class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t\t<tr clas"
  "s=\"spacer\">\n\t\t\t\t\t\t<td colspan=\"4\"/>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td colsp"
  "an=\"4\"><div class=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td"
  " class=\"action leftcol \"></td>\n\t\t\t\t\t\t<td class=\"topaligned \"><div class=\"withmargin\"><a href=\"schedule."
  "html\?channel=\"></a></div></td>\n\t\t\t\t\t\t<td class=\"topaligned \"><div class=\"withmargin nowrap\"> - </div></t"
  "d>\n\t\t\t\t\t\t<td class=\"topaligned rightcol \"><div class=\"more withmargin\"><a ><span class=\"title\"></span><b"
  "r /><span class=\"short\">&nbsp;</span></a></div></td>\n\t\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</htm"
  "l>\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchresults " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string searchtimerid = tnt::stringTo<string>("searchtimerid", "string", qparam.param("searchtimerid"), reply.out().getloc());
string searchtimerquery = tnt::stringTo<string>("searchtimerquery", "string", qparam.param("searchtimerquery"), reply.out().getloc());
string searchplain = tnt::stringTo<string>("searchplain", "string", qparam.param("searchplain"), reply.out().getloc());
  // </%args>

#line 19 "searchresults.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 22 "searchresults.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = tr("Search results");
	SearchResults results;
	if (!searchtimerid.empty())
		results.GetByID(lexical_cast< int >(searchtimerid));
	if (!searchtimerquery.empty())
		results.GetByQuery(SearchResults::PopQuery(searchtimerquery));
	if (!searchplain.empty())
	{
		SearchTimer s;
		s.SetId(0);
		s.SetSearch(searchplain);
		s.SetSearchMode(0);
		s.SetUseTitle(true);
		s.SetUseSubtitle(false);
		s.SetUseDescription(false);
		results.GetByQuery(s.ToText());
	}

  // <& pageelems.doc_type ...
  { 
#line 43 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 43 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 46 "searchresults.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 47 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 47 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 48 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 48 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 51 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 51 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 52 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 52 "searchresults.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("searchepg"), reply.out().getloc() ) );
#line 52 "searchresults.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 54 "searchresults.ecpp"
			if (results.size() == 0) {

  reply.out() << data[6]; // \t\t\t\t
#line 55 "searchresults.ecpp"
  reply.sout() << ( tr("No search results") );
  reply.out() << data[7]; // \n
#line 56 "searchresults.ecpp"
			}

  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 58 "searchresults.ecpp"

				string current_day = "";

#if VDRVERSNUM >= 20301
				LOCK_CHANNELS_READ;
#endif
				for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
#if VDRVERSNUM >= 20301
					cChannel* channel = (cChannel *)Channels->GetByChannelID(result->Channel());
#else
					cChannel* channel = Channels.GetByChannelID(result->Channel());
#endif
					if (!channel) continue;
					string channelname = channel->Name();
					int channelnr = channel->Number();
					string start(result->StartTime() ? FormatDateTime(tr("%I:%M %p"), result->StartTime()) : "");
					string end(result->StopTime() ? FormatDateTime(tr("%I:%M %p"), result->StopTime()) : "");
					string day(result->StartTime() ? FormatDateTime(tr("%A, %b %d %Y"), result->StartTime()) : "");
					string description = result->Description();
					string epgid = EpgEvents::EncodeDomId(result->Channel(), result->EventId());

					bool truncated = false;

					bool bottom = false;
					SearchResults::iterator nextResult = result; ++nextResult;
					if (nextResult == results.end())
						bottom = true;
					else {
						string nextDay(nextResult->StartTime() ? FormatDateTime(tr("%A, %b %d %Y"), nextResult->StartTime()) : "");
						bottom = (day != nextDay);
					}

					if (current_day != day) {
						if (current_day != "") {

  reply.out() << data[9]; // \t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t<td colspan="4"/>\n\t\t\t\t\t</tr>\n
#line 96 "searchresults.ecpp"
						}

  reply.out() << data[10]; // \t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td colspan="4"><div class="boxheader"><div><div>
#line 98 "searchresults.ecpp"
  reply.sout() << ( day );
  reply.out() << data[11]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n
#line 100 "searchresults.ecpp"
						current_day = day;

#line 101 "searchresults.ecpp"
					}

  reply.out() << data[12]; // \t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="action leftcol 
#line 103 "searchresults.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow";
  reply.out() << data[13]; // ">
  // <& pageelems.event_timer ...
  { 
#line 103 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 103 "searchresults.ecpp"
    _tnt_cq5.add( "epgid", tnt::toString((epgid), reply.out().getloc() ) );
#line 103 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[14]; // </td>\n\t\t\t\t\t\t<td class="topaligned 
#line 104 "searchresults.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow";
  reply.out() << data[15]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 104 "searchresults.ecpp"
  reply.sout() << ( channelnr );
  reply.out() << data[16]; // ">
#line 104 "searchresults.ecpp"
  reply.sout() << ( channelname );
  reply.out() << data[17]; // </a></div></td>\n\t\t\t\t\t\t<td class="topaligned 
#line 105 "searchresults.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow";
  reply.out() << data[18]; // "><div class="withmargin nowrap">
#line 105 "searchresults.ecpp"
  reply.sout() << ( start );
  reply.out() << data[19]; //  - 
#line 105 "searchresults.ecpp"
  reply.sout() << ( end );
  reply.out() << data[20]; // </div></td>\n\t\t\t\t\t\t<td class="topaligned rightcol 
#line 106 "searchresults.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow";
  reply.out() << data[21]; // "><div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 106 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 106 "searchresults.ecpp"
    _tnt_cq6.add( "text", tnt::toString((StringEscapeAndBreak(StringWordTruncate(description, 300, truncated)) + "<br />" + tr("Click to view details.")), reply.out().getloc() ) );
#line 106 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 106 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 106 "searchresults.ecpp"
    _tnt_cq7.add( "domId", tnt::toString((epgid), reply.out().getloc() ) );
#line 106 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[22]; // ><span class="title">
#line 106 "searchresults.ecpp"
  reply.sout() << ( result->Title() );
  reply.out() << data[23]; // </span><br /><span class="short">
#line 106 "searchresults.ecpp"
if (result->ShortText().empty()) { 
  reply.out() << data[24]; // &nbsp;
#line 106 "searchresults.ecpp"
 } 
#line 106 "searchresults.ecpp"
  reply.sout() << ( result->ShortText() );
  reply.out() << data[25]; // </span></a></div></td>\n\t\t\t\t\t</tr>\n
#line 108 "searchresults.ecpp"
				}

  reply.out() << data[26]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << data[27]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[28]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
