////////////////////////////////////////////////////////////////////////
// timerconflicts.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timerconflicts")

// <%pre>
#line 1 "timerconflicts.ecpp"


#include <timerconflict.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timers.h>

using namespace vdrlive;
using namespace std;

static const size_t maximumDescriptionLength = 300;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("timerconflicts");

static const char* rawData = "\344\000\000\000\010\001\000\000\023\001\000\000\026\001\000\000*\001\000\000-\001\000"
  "\000E\001\000\000I\001\000\000J\001\000\000\205\001\000\000\337\001\000\000\261\002\000\000\340\002\000\000\017\003"
  "\000\000>\003\000\000m\003\000\000\234\003\000\000I\005\000\000p\005\000\000|\005\000\000\205\005\000\000\245\005\000"
  "\000\336\005\000\000\340\005\000\000\003\006\000\000$\006\000\000C\006\000\000d\006\000\000\203\006\000\000\235\006"
  "\000\000\274\006\000\000\331\006\000\000\342\006\000\000\343\006\000\000\354\006\000\000\017\007\000\0000\007\000\000"
  "V\007\000\000\200\007\000\000\214\007\000\000\225\007\000\000\300\007\000\000\337\007\000\000\371\007\000\000\002\010"
  "\000\000-\010\000\000/\010\000\000X\010\000\000w\010\000\000\221\010\000\000\232\010\000\000\270\010\000\000\377\010"
  "\000\000\013\t\000\000%\t\000\000&\t\000\000(\t\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t"
  "\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing="
  "\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t\t<td colspan=\"11\">\n\t\t\t\t\t\t\t\t<div cl"
  "ass=\"boxheader\"><div><div></div></div></div>\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class=\"descr"
  "iption\">\n\t\t\t\t\t\t\t<td class=\"leftcol\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px"
  "\" /></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></di"
  "v></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div><"
  "/td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td"
  ">\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td"
  ">\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td"
  ">\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td"
  ">\n\t\t\t\t\t\t\t<td class=\"action rightcol\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px"
  "\" /></td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"leftcol \"><img src=\"\" alt=\"\" ></i"
  "mg></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a href=\"schedule.html\?channel=\"></a></div></td"
  ">\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div c"
  "lass=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"></div></td>\n\t\t\t"
  "\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a\n\t\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t></a></div></td>\n\t\t\t\t"
  "\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"action \"><a href=\""
  "searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t\t<td class=\"action \"><a "
  "href=\"timers.html\?timerid=&action=toggle\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t\t<td class=\"act"
  "ion \"></td>\n\t\t\t\t\t\t\t\t<td class=\"action rightcol \"><a href=\"timers.html\?timerid=&action=delete\"><img src"
  "=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t</tr>\n</%cpp\n\t\t\t\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t\t\t<td co"
  "lspan=\"10\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timerconflicts " << qparam.getUrl());

  tnt::DataChunks data(rawData);

#line 19 "timerconflicts.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 22 "timerconflicts.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 25 "timerconflicts.ecpp"

	pageTitle = tr("Timer conflicts");
	TimerConflicts timerConflicts;
	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

  // <& pageelems.doc_type ...
  { 
#line 31 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 31 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 34 "timerconflicts.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 35 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 35 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 36 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 36 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 39 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 39 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 40 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 40 "timerconflicts.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("timersconflicts"), reply.out().getloc() ) );
#line 40 "timerconflicts.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 42 "timerconflicts.ecpp"
			if (timerConflicts.size() == 0) {

  reply.out() << data[6]; // \t\t\t\t
#line 43 "timerconflicts.ecpp"
  reply.sout() << ( tr("No timer conflicts") );
  reply.out() << data[7]; // \n
#line 44 "timerconflicts.ecpp"
			} else {

  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 46 "timerconflicts.ecpp"

				for (TimerConflicts::iterator conflict = timerConflicts.begin(); conflict != timerConflicts.end(); ++conflict) {
					const std::list< TimerInConflict >& conflTimers = conflict->ConflictingTimers();
					for (std::list< TimerInConflict >::const_iterator confltimer = conflTimers.begin(); confltimer != conflTimers.end(); ++confltimer) {

  reply.out() << data[9]; // \t\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t\t<td colspan="11">\n\t\t\t\t\t\t\t\t<div class="boxheader"><div><div>
#line 53 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%A, %x"), conflict->ConflictTime()) + " " + FormatDateTime(tr("%I:%M %p"), conflict->ConflictTime()) + " - " + lexical_cast<string, int>(confltimer->percentage) + "%" );
  reply.out() << data[10]; // </div></div></div>\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class="description">\n\t\t\t\t\t\t\t<td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 58 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << data[11]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 59 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << data[12]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 60 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << data[13]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 61 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << data[14]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 62 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << data[15]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 63 "timerconflicts.ecpp"
  reply.sout() << ( tr("Searchtimer") );
  reply.out() << data[16]; // </div></td>\n\t\t\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action rightcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t</tr>\n
#line 69 "timerconflicts.ecpp"

						for (std::list<int>::const_iterator timerIndex = confltimer->concurrentTimerIndices.begin(); timerIndex != confltimer->concurrentTimerIndices.end(); ++timerIndex) {
#if VDRVERSNUM >= 20301
							LOCK_TIMERS_READ;
							cTimer* timer = (cTimer *)Timers->Get(*timerIndex-1);
#else
							cTimer* timer = Timers.Get(*timerIndex-1);
#endif
							if (!timer) continue;

							std::list< int >::const_iterator nexttimerIndex = timerIndex;
							++nexttimerIndex;
							bool bottom = (nexttimerIndex == confltimer->concurrentTimerIndices.end());

							std::string timerStateImg = "transparent.png";
							std::string timerStateHint;
							if (timer->Index() == confltimer->timerIndex-1) {
								timerStateImg = "timerconflict.gif";
								timerStateHint = tr("Timer has a conflict.");
							}
							else if (timer->Flags() & tfActive) {
								timerStateImg = "arrow.png";
								timerStateHint = tr("Timer is active.");
							}

							EpgInfoPtr epgEvent;
							string longDescription;
							string searchTimName;
							string title;
#if VDRVERSNUM >= 20301
							if (!timer->Event()) {
								LOCK_SCHEDULES_READ;
								timer->SetEventFromSchedule(Schedules);
							}
#else
							if (!timer->Event()) timer->SetEventFromSchedule();
#endif
							if (timer->Event()) {
								epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
								longDescription = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer)) + "<hr>"
													+ StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
													+ "<br/><br/>" + tr("Click to view details.");
								searchTimName = SortedTimers::SearchTimerName(*timer);
								title = epgEvent->Title();
							}

  reply.out() << data[17]; // \t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="leftcol 
#line 116 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[18]; // "><img src="
#line 116 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << data[19]; // " alt="" 
#line 116 "timerconflicts.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 116 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 116 "timerconflicts.ecpp"
    _tnt_cq5.add( "text", tnt::toString((timerStateHint), reply.out().getloc() ) );
#line 116 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 116 "timerconflicts.ecpp"
 } 
  reply.out() << data[20]; // ></img></td>\n\t\t\t\t\t\t\t\t<td class="
#line 117 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[21]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 117 "timerconflicts.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << data[22]; // ">
#line 117 "timerconflicts.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << data[23]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 118 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[24]; // "><div class="withmargin nowrap">
#line 118 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << data[25]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 119 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[26]; // "><div class="withmargin nowrap">
#line 119 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << data[27]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 120 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[28]; // "><div class="withmargin">
#line 120 "timerconflicts.ecpp"
  reply.sout() << ( timer->Priority() );
  reply.out() << data[29]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 121 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[30]; // "><div class="withmargin"><a\n
#line 122 "timerconflicts.ecpp"
								if (!longDescription.empty()) {

  reply.out() << data[31]; // \t\t\t\t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 123 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 123 "timerconflicts.ecpp"
    _tnt_cq6.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 123 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 123 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 123 "timerconflicts.ecpp"
    _tnt_cq7.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 123 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[32]; // \n
#line 124 "timerconflicts.ecpp"
								}

  reply.out() << data[33]; // \t\t\t\t\t\t\t\t>
#line 125 "timerconflicts.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << data[34]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 126 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[35]; // "><div class="withmargin nowrap">
#line 126 "timerconflicts.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << data[36]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 127 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[37]; // "><a href="searchresults.html\?searchplain=
#line 127 "timerconflicts.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << data[38]; // "><img src="
#line 127 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << data[39]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 127 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 127 "timerconflicts.ecpp"
    _tnt_cq8.add( "text", tnt::toString((tr("Search for repeats.")), reply.out().getloc() ) );
#line 127 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[40]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 128 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[41]; // "><a href="timers.html\?timerid=
#line 128 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[42]; // &action=toggle"><img src="
#line 128 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << data[43]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 128 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 128 "timerconflicts.ecpp"
    _tnt_cq9.add( "text", tnt::toString((tr("Toggle timer active/inactive")), reply.out().getloc() ) );
#line 128 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[44]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 129 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[45]; // ">
  // <& pageelems.edit_timer ...
  { 
#line 129 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 129 "timerconflicts.ecpp"
    _tnt_cq10.add( "timerId", tnt::toString((timers.GetTimerId(*timer)), reply.out().getloc() ) );
#line 129 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[46]; // </td>\n\t\t\t\t\t\t\t\t<td class="action rightcol 
#line 130 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[47]; // "><a href="timers.html\?timerid=
#line 130 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[48]; // &action=delete"><img src="
#line 130 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[49]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 130 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 130 "timerconflicts.ecpp"
    _tnt_cq11.add( "text", tnt::toString((tr("Delete timer")), reply.out().getloc() ) );
#line 130 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[50]; // ></img></a></td>\n\t\t\t\t\t\t\t</tr>\n
#line 132 "timerconflicts.ecpp"
						}

  reply.out() << data[51]; // </%cpp\n\t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="10"/>\n\t\t\t\t\t\t</tr>\n
#line 137 "timerconflicts.ecpp"

					}
				}

  reply.out() << data[52]; // \t\t\t</table>\n
#line 142 "timerconflicts.ecpp"
			}

  reply.out() << data[53]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[54]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[55]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
