////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"


#include <timers.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <users.h>

using namespace std;
using namespace vdrlive;

static const size_t maximumDescriptionLength = 300;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class timer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        timer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    timer_actions_type timer_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "\324\000\000\000\370\000\000\000\003\001\000\000\006\001\000\000\032\001\000\000\035\001"
  "\000\0005\001\000\0009\001\000\000:\001\000\000u\001\000\000\264\001\000\000\017\002\000\000\336\002\000\000\013\003"
  "\000\0008\003\000\000e\003\000\000\222\003\000\000\324\004\000\000\365\004\000\000\001\005\000\000\n\005\000\000'\005"
  "\000\000`\005\000\000b\005\000\000\202\005\000\000\243\005\000\000\277\005\000\000\340\005\000\000\374\005\000\000"
  "\031\006\000\000\037\006\000\000 \006\000\000'\006\000\000M\006\000\000g\006\000\000\212\006\000\000\251\006\000\000"
  "\303\006\000\000\314\006\000\000\364\006\000\000\366\006\000\000\034\007\000\000;\007\000\000U\007\000\000^\007\000"
  "\000y\007\000\000\237\007\000\000\240\007\000\000\241\007\000\000\273\007\000\000\300\007\000\000\371\007\000\000\376"
  "\007\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div"
  " class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t<tr cl"
  "ass=\"spacer\">\n\t\t\t\t\t\t\t<td colspan=\"8\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td col"
  "span=\"9\">\n\t\t\t\t\t\t<div class=\"boxheader\"><div><div>\n\t\t\t\t\t\t\t\n\t\t\t\t\t\t</div></div></div>\n\t\t\t"
  "\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"description\">\n\t\t\t\t\t<td class=\"leftcol\"><img src=\"img/transpar"
  "ent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t"
  "\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><"
  "div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"acti"
  "on\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td class=\"action\""
  "><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td class=\"action right"
  "col\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n"
  "\n\t\t\t\t<td class=\"leftcol \"><img src=\"\" alt=\"\" ></img></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargi"
  "n\"><a href=\"schedule.html\?channel=\"></a></div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></"
  "div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t<td class=\"\"><div class"
  "=\"withmargin\"><a\n\t\t\t\t\t\t\n\t\t\t\t\t\t></a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\"\"><div class=\"wit"
  "hmargin\"></div></td>\n\t\t\t\t\t<td class=\"action \"><a href=\"timers.html\?timerid=&action=toggle\"><img src=\"\" "
  "alt=\"\" ></img></a></td>\n\t\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t\t<td class=\"action rightcol \"><a href=\""
  "timers.html\?timerid=&action=delete\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</d"
  "iv>\n\t</body>\n</html>\n\n\n<a href=\"edit_timer.html\"></a>\n<span class=\"sep\">|</span>\n<a href=\"timerconflicts"
  ".html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    timer_actions(*this, "timer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string timerid = tnt::stringTo<string>("timerid", "string", qparam.param("timerid"), reply.out().getloc());
string action = tnt::stringTo<string>("action", "string", qparam.param("action"), reply.out().getloc());
  // </%args>

#line 23 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 26 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(timer_type, timer, "const cTimer* timer", ());   // <%request> const cTimer* timer
#line 27 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%request> TimerConflictNotifier timerNotifier
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 30 "timers.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Timers");

	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	if ( !timerid.empty() ) {
		string tId = SortedTimers::DecodeDomId(timerid);
		// dsyslog("DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
		if (action == "delete") {
			if (!cUser::CurrentUserHasRightTo(UR_DELTIMERS))
				throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
			LiveTimerManager().DelTimer(timer);
			timerNotifier.SetTimerModification();
			return reply.redirect("timers.html");
		}
		if (action == "toggle") {
			LiveTimerManager().ToggleTimerActive(timer);
			timerNotifier.SetTimerModification();
			return reply.redirect("timers.html");
		}
	}

	string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 61 "timers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 61 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 64 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 65 "timers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 65 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 66 "timers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 66 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 69 "timers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 69 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 70 "timers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 70 "timers.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("timers"), reply.out().getloc() ) );
#line 70 "timers.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("timers.timer_actions"), reply.out().getloc() ) );
#line 70 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 72 "timers.ecpp"
			if (timers.size() == 0) {

  reply.out() << data[6]; // \t\t\t\t
#line 73 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << data[7]; // \n
#line 74 "timers.ecpp"
			} else {

  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 76 "timers.ecpp"

				// output of the timer list:
				for (SortedTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
				    EpgInfoPtr epgEvent;
					string longDescription;
					string searchTimName;
#if VDRVERSNUM >= 20301
					if (!timer->Event()) {
						LOCK_SCHEDULES_READ;
						timer->SetEventFromSchedule(Schedules);
					}
#else
					if (!timer->Event()) timer->SetEventFromSchedule();
#endif
					if (timer->Event())
					{
						epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
						longDescription = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer)) + "<hr>"
											+ StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
											+ "<br/><br/>" + tr("Click to view details.");
						searchTimName = SortedTimers::SearchTimerName(*timer);
					}
					string currentDay = SortedTimers::GetTimerDays(*timer);
					SortedTimers::iterator nextTimer = timer; ++nextTimer;
					bool bottom = false;
					if (nextTimer == timers.end())
						bottom = true;
					else {
						string nextDay = SortedTimers::GetTimerDays(*nextTimer);
						bottom = (currentDay != nextDay);
					}
					if (previousDay != currentDay) {
						if (!previousDay.empty()) {

  reply.out() << data[9]; // \t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="8"/>\n\t\t\t\t\t\t</tr>\n
#line 113 "timers.ecpp"

						}
						previousDay = currentDay;

  reply.out() << data[10]; // \t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="9">\n\t\t\t\t\t\t<div class="boxheader"><div><div>\n\t\t\t\t\t\t\t
#line 120 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << data[11]; // \n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 126 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << data[12]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 127 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << data[13]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 128 "timers.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << data[14]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 129 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << data[15]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 130 "timers.ecpp"
  reply.sout() << ( tr("Searchtimer") );
  reply.out() << data[16]; // </div></td>\n\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action rightcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t</tr>\n
#line 135 "timers.ecpp"

					}
					std::string timerStateImg = "transparent.png";
					std::string timerStateHint;
					if (timer->Recording()) {
						timerStateImg = "arrow_rec.gif";
						timerStateHint = tr("Timer is recording.");
					}
					else if (timer->Flags() & tfActive) {
						timerStateImg = "arrow.png";
						timerStateHint = tr("Timer is active.");
					}

  reply.out() << data[17]; // \t\t\t\t<tr>\n\n\t\t\t\t<td class="leftcol 
#line 150 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[18]; // "><img src="
#line 150 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << data[19]; // " alt="" 
#line 150 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 150 "timers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 150 "timers.ecpp"
    _tnt_cq5.add( "text", tnt::toString((timerStateHint), reply.out().getloc() ) );
#line 150 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 150 "timers.ecpp"
 } 
  reply.out() << data[20]; // ></img></td>\n\t\t\t\t\t<td class="
#line 151 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[21]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 151 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << data[22]; // ">
#line 151 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << data[23]; // </a></div></td>\n\t\t\t\t\t<td class="
#line 152 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[24]; // "><div class="withmargin nowrap">
#line 152 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << data[25]; // </div></td>\n\t\t\t\t\t<td class="
#line 153 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[26]; // "><div class="withmargin nowrap">
#line 153 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << data[27]; // </div></td>\n\t\t\t\t\t<td class="
#line 154 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[28]; // "><div class="withmargin"><a\n
#line 155 "timers.ecpp"
					if (!longDescription.empty()) {

  reply.out() << data[29]; // \t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 156 "timers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 156 "timers.ecpp"
    _tnt_cq6.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 156 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 156 "timers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 156 "timers.ecpp"
    _tnt_cq7.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 156 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[30]; // \n
#line 157 "timers.ecpp"
					}

  reply.out() << data[31]; // \t\t\t\t\t\t>
#line 158 "timers.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << data[32]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="
#line 160 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[33]; // "><div class="withmargin">
#line 160 "timers.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << data[34]; // </div></td>\n\t\t\t\t\t<td class="action 
#line 161 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[35]; // "><a href="timers.html\?timerid=
#line 161 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[36]; // &action=toggle"><img src="
#line 161 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << data[37]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 161 "timers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 161 "timers.ecpp"
    _tnt_cq8.add( "text", tnt::toString((tr("Toggle timer active/inactive")), reply.out().getloc() ) );
#line 161 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[38]; // ></img></a></td>\n\t\t\t\t\t<td class="action 
#line 162 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[39]; // ">
  // <& pageelems.edit_timer ...
  { 
#line 162 "timers.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 162 "timers.ecpp"
    _tnt_cq9.add( "timerId", tnt::toString((timers.GetTimerId(*timer)), reply.out().getloc() ) );
#line 162 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[40]; // </td>\n\t\t\t\t\t<td class="action rightcol 
#line 163 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[41]; // "><a href="timers.html\?timerid=
#line 163 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[42]; // &action=delete"><img src="
#line 163 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[43]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 163 "timers.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 163 "timers.ecpp"
    _tnt_cq10.add( "text", tnt::toString((tr("Delete timer")), reply.out().getloc() ) );
#line 163 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[44]; // ></img></a></td>\n\t\t\t\t</tr>\n
#line 165 "timers.ecpp"

				}
			}

  reply.out() << data[45]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[46]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[47]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::timer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::timer_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 26 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(timer_type, timer, "const cTimer* timer", ());   // <%request> const cTimer* timer
#line 27 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%request> TimerConflictNotifier timerNotifier
#line 23 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[48]; // <a href="edit_timer.html">
#line 176 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << data[49]; // </a>\n
#line 177 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << data[50]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 179 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << data[51]; // </a>\n
#line 180 "timers.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
